import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.Map; 
import ddf.minim.*; 
import ddf.minim.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class growing extends PApplet {




PFont f;
Board current;

int board_width;
int board_height;

public void load_map(String name) {
  current = new Board(name);
  current.init_objects();

}

public void setup() {
  

  board_width = width/SIZE;
  board_height = height/SIZE;

  load_map("menu");

  sound_init();

  /* // affiche toute les polices disponibles dans la console */
  /* printArray(PFont.list()); */

  // chargement de la police Arial
  f = createFont("Arial", width/10);
  textFont(f);
  textAlign(CENTER,CENTER);

  // changement du framerate
  frameRate(20);

  // loading image
  PImage tilesFile = loadImage("map-tile.png");
  for(int i = 0; i < 10; i++){
    for(int j = 0; j < 4; j++){ /* do not forget to make it grow as needed */
      tiles[i+10*j] = tilesFile.get(i*SIZE,j*SIZE,SIZE,SIZE);
    }
  }
  againSetup();
}

public void draw() {
  if(dead) {
    againDisplay();
  } else {
    current.display();
  }
}
final int SIZE = 32;
final int marge = 5;
final int osd = 3;

class Board {
  int left_corner;
  int up_corner;

  HashMap<Integer, Things> board;
  Carte carte;

  Root r;
  Player player;

  Board(String name) {
    left_corner = 0;
    up_corner = 0;
    board = new HashMap<Integer, Things>();
    carte = new Carte(name);
  }

  public Things object_from_type(int type, int x, int y) {
    return object_from_type(type, x, y,null);
  }

  public Things object_from_type(int type, int x, int y, JSONObject parameter) {
    Things t;
    switch(type) {
    case(waterTiles):
      t = new Water(x,y);
      break;
    case(rockTiles):
      t = new Rock(x,y);
      break;
    case(warpTiles):
      t = new Warp(x,y,parameter.getString("destination"));
      break;
    case(seedTiles):
      r = new Root(x,y);
      t = r.seed();
      player = new Player(r,t,carte.energy);
      left_corner = max(x - board_width/2,0);
      up_corner = max(y - board_width/2,0);
      break;
    default:
      t = new Dirt(x, y);
      break;
    }

    return t;
  }

  public void init_objects() {
    for(int i = 0; i < carte.objects.size(); i++){
      JSONObject obj = carte.objects.getJSONObject(i);
      int x = obj.getInt("x")/SIZE;
      int y = obj.getInt("y")/SIZE;

      Things t = object_from_type(obj.getInt("gid")-1,x,y,obj.getJSONObject("properties"));
    }
  }

  public void maybe_scroll(int x, int y){
    if(x - marge < left_corner) {
      left_corner--;
    } else if(x+marge+osd > left_corner + board_width) {
      left_corner++;
    }
    if(y - marge < up_corner) {
      up_corner--;
    } else if(y + marge > up_corner + board_height) {
      up_corner++;
    }
    if(up_corner < 0) {
      up_corner = 0;
    }
  }

  public int coordinate_hash(int x, int y) { /* from number therorie: no two number map to the same number */
    int a, b, n;
    if(x<0){
      a = -2*x;
    } else {
      a = 2 * x + 1;
    }
    if(y<0){
      b = -2*y;
    } else {
      b = 2 * y + 1;
    }
    n = a + b;
    return n*(n+1)/2+a;
  }

  public void display() {
    background(0xff,0xff,0xff);

    pushMatrix();
    translate(-left_corner * SIZE, -up_corner * SIZE);
    for (Map.Entry me : board.entrySet()) {
      ((Things)me.getValue()).display();
    }
    popMatrix();

    player.display();

    if(keyPressed) {
      player.keyPressed();
    }
  }

  public void put(int x, int y, Things t) {
    board.put(coordinate_hash(x,y),t);
  }

  public Things get(int x, int y) {
    Things t = board.get(coordinate_hash(x,y));
    if(t == null) {
      int type;
      if( x < 0 || y < 0 || x >= carte.width || y >= carte.height) {
        type = rockTiles;
      } else {
        type = carte.get(x,y);
      }

      t = object_from_type(type, x, y);
    }
    return t;
  }
}


class Things {
  int xpos, ypos;

  boolean selected = false;

  Root r;
  boolean[] connected={ false, false, false, false};
  Things[] next = new Things[4];

  Things(int x, int y){
    xpos = x;
    ypos = y;
    current.put(x,y,this);

    for(int i=0; i < 4 ; i++){
      next[i] = this;
    }
  }

  public boolean accept() {
    return false;               /* Can we connect */
  }


  public Things accepting(Things from, int dir) {
    r = from.r;
    connected[dir] = true;
    next[dir] = from;
    return this;
  }

  public Things move(int dir) {
    if(connected[dir]){
      return next[dir];
    }

    int newx=xpos;
    int newy=ypos;

    switch(dir){
    case DIRUP:
      newy--;
      break;
    case DIRLEFT:
      newx--;
      break;
    case DIRDOWN:
      newy++;
      break;
    case DIRRIGHT:
      newx++;
      break;
    default:
      exit();
    }

    Things atdest = current.get(newx,newy);

    if( !atdest.accept()){
      return this;              /* can go there */
    } else {
      atdest = atdest.accepting(this, oposite_dir(dir));
      connected[dir] = true;
      next[dir] = atdest;
      return atdest;            /* should do something! */
    }
  }

  public void select() {
    selected = true;
  }

  public void unselect() {
    selected = false;
  }

  public void display() {
  }

  public void display_connected(boolean displayEmpty) {
    if(selected) {
      fill(0xCD,0xDC,0x39);
      rect(xpos * SIZE, ypos * SIZE,SIZE,SIZE,SIZE/5);
    };
    if(displayEmpty) {
      image(tiles[rootTiles],xpos * SIZE, ypos * SIZE);
    }
    for(int i=0; i<4; i++){
      if(connected[i]){
        image(tiles[rootTiles+1+i],xpos * SIZE, ypos * SIZE);
      }
    }

  }
}

class Dirt extends Things {
  int resistance = 2;
  int trying = 0;

  Dirt(int x, int y) {
    super(x, y);
    if(y==0){
      resistance = 1;
    };
  }

  Dirt(int x, int y, int r) {
    super(x, y);
    resistance = r;
  }

  public void display() {
    if(trying > 0) {
      stroke(0);
      trying--;
    } else {
      noStroke();
    }
    rect(xpos * SIZE, ypos * SIZE,SIZE,SIZE,SIZE/5);
    if(ypos == 0) {
      image(tiles[groundTiles], xpos * SIZE, ypos * SIZE);
    } else {
      image(tiles[resistance], xpos * SIZE, ypos * SIZE);
    }
    noFill();
  }

  public boolean accept() {
    if(trying > 0 && resistance == 0) {
      return true;
    } else if(trying > 0) {
      resistance--;
    }
    trying = 4;
    if(! digging.isPlaying()) {
      digging.play(0);
    }

    return false;               /* Can we connect */
  }

  public Things accepting(Things from, int dir) {
    if(ypos == 0){
      Trunk tr = new Trunk(xpos, ypos, dir, from);
      from.r.add(tr);
      current.player.addTrunk();
      return tr;
    } else {
      RootPart root = new RootPart(xpos, ypos, dir, from);

      current.player.addRoot();
      from.r.add(root);
      return root;
    }
  }
}

class Water extends Things {
  Water(int x, int y) {
    super(x, y);
  }

  public boolean accept() {
    for(int i=0; i<4; i++){     /* copied from root... berk */
      if(connected[i]){
        return false;
      }
    }
    if(! splach.isPlaying()) {
      splach.play(0);
    }
    current.player.addWater();

    return true;
  }

  public void display() {
    image(tiles[waterTiles],xpos * SIZE, ypos * SIZE);

    super.display_connected(false);
  }
}

class Rock extends Things {
  Rock(int x, int y) {
    super(x, y);
  }

  public boolean accept() {
    return false;
  }

  public void display() {
    image(tiles[rockTiles],xpos * SIZE, ypos * SIZE);
  }
}

class Warp extends Things {
  String destination;
  Warp(int x, int y, String dest) {
    super(x, y);
    destination = dest;
  }

  public boolean accept() {
    load_map(destination);
    return true;
  }

  public void display() {
    image(tiles[warpTiles],xpos * SIZE, ypos * SIZE);
  }
}
boolean dead = false;

Box yes, no, title;

public void againSetup() {
  title = new Box( width/4,1*height/5,width/2,height/5,255 );
  yes   = new Box( width/5,3*height/5,width/5,height/5,255 );
  no    = new Box( 3*width/5,3*height/5,width/5,height/5,255 );
}

public void againDisplay() {
  title.display();
  yes.display();
  no.display();

  fill(0);
  text("Again ?",width/2,3*height/10-10);
  text("Yes",3*width/10,7*height/10-10);
  text("No",7*width/10,7*height/10-10);
}

public void mouseClicked() {
  if(dead) {
    if(yes.over()){
      dead = false;
      load_map(current.carte.name);
    }
    if(no.over()){
      exit();
    }
  }
}

class Box{
  //     These are the things a box 'knows' (they're put up here to indicate that):
  int xpos,ypos;    //  where it is,
  int sizx;          //  how big it is
  int sizy;          //  how big it is
  int col;          //  what color it is, and
  boolean sel;      //  whether it is selected.


  Box( int x, int y, int sx, int sy, int c ){
    this.xpos = x;
    this.ypos = y;
    this.sizx = sx;
    this.sizy = sy;
    this.col = c;
    this.sel=false;
  }


  // One thing our box better know how to do is display (draw) itself when told to. It does this by
  // making normal drawing-environment changes appropriate to the desired result.

  public void display (){
    fill(col);
    stroke(0);
    if(this.sel) fill(100);
    rect( xpos,ypos,sizx,sizy );
  }

  // Another useful thing for the box to know is whether a particular test position (x,y)is "on top" of it.
  // Being a box, this basically means testing whether the test-x is between the left and right edges, and
  // whether the test-y is between bottom and top. If both of those things are true, the point is ON the box!

  public boolean over(){
    return ( xpos < mouseX && mouseX < xpos + sizx && ypos < mouseY && mouseY < ypos + sizy );
  }

  // the box knows how to move itself a specified distance (basically it just updates it's position)

  public void move(int dx, int dy){
    this.xpos += dx;
    this.ypos += dy;
  }

  // and it knows how to become selected and deselected, and you can ask it if it is selected.

  public void select(){
    this.sel=true;
  }

  public boolean selected(){
    return this.sel;
  }

  public void deselect(){
    this.sel=false;
  }
}
class Player {
  Root r;
  Things pos;

  float water;
  float trunk;
  float root;
  float energy;

  Player(Root theroot, Things seed, int e) {
    r = theroot;
    pos = seed;
    pos.select();
    energy = e;
    water = 0;
    trunk = 0;
    root = 1;
  }

  public void spendEnergy() {
    energy--;
  }

  public void addWater() {
    water++;
  }

  public void addTrunk() {
    trunk++;
  }

  public void addRoot() {
    root++;
  }

  boolean moving = true;

  public void move(int dir) {
    if(moving) {
      pos.unselect();
      pos = pos.move(dir);
      pos.select();
      int x = pos.xpos; int y = pos.ypos;
      current.maybe_scroll(x,y);
      current.get(x+1,y);
      current.get(x-1,y);
      current.get(x,y+1);
      current.get(x,y-1);
    } else {
      moving = false;
    }
  }

  public void keyPressed() {
    if(key == CODED) {
      switch(keyCode) {
      case UP:
        move(DIRUP);
        break;
      case DOWN:
        move(DIRDOWN);
        break;
      case LEFT:
        move(DIRLEFT);
        break;
      case RIGHT:
        move(DIRRIGHT);
        break;
      }
    } else {
      switch(key) {
      case 'z':
      case 'w':
      case '\u00e9':
        move(DIRUP);
        break;
      case 's':
      case 'u':
        move(DIRDOWN);
        break;
      case 'q':
      case 'a':
        move(DIRLEFT);
        break;
      case 'd':
      case 'i':
        move(DIRRIGHT);
        break;
      }
    }
  }

  public void drawBar(int max, float value) {
    rect(width-96,max-value,96,value);
  }

  public void display() {
    float deltaEnergy = min(water/10,trunk) - root/50;

    fill(0x20,0x24,0x25);
    noStroke();
    rect(width-96,0,96,height);

    if(deltaEnergy < 0) {
      float e = energy;
      fill(0xff,0x08,0x25);
      drawBar(height,energy);

      energy+=deltaEnergy;

      fill(0x08,0xf0,0x25);
      drawBar(height,min(energy,e-1));
    } else {
      float e = energy;
      energy+=deltaEnergy;

      fill(0x08,0xff,0x25);
      drawBar(height,energy);

      fill(0x08,0xf0,0x25);
      drawBar(height,min(e,energy-1));
    }

    if(energy < 0) {
      dead = true;
    }

    fill(0xFD,0xB8,0x13);
    drawBar((int)trunk*10,trunk*10);

    fill(0x13,0xB8,0xFD);
    drawBar((int)trunk*10,water);
  }
}


AudioPlayer player;
Minim minim;//audio context

AudioPlayer digging;
AudioPlayer splach;

public void sound_init() {
  minim = new Minim(this);
  player = minim.loadFile("data/remi_vanicat - Sound of nature.mp3", 2048);
  player.loop();
  digging = minim.loadFile("data/grat.mp3", 2048);
  splach = minim.loadFile("data/sploou.mp3", 2048);
}

public void stop()
{
  println("stop???");
  player.close();
  minim.stop();
  super.stop();
}
PImage[] tiles = new PImage[10*10];

final int rootTiles = 15;
final int seedTiles = 15;
final int waterTiles = 9;
final int trunkTiles = 11;
final int groundTiles = 10;
final int easyDirtTiles = 0;
final int dirtTiles = 4;
final int rockTiles = 5;
final int warpTiles = 6;

class Carte {
  int height;
  int width;
  int energy;
  String name;
  int[] themap;
  JSONArray objects;

  Carte(String theName) {
    JSONObject data;

    name = theName;

    data = loadJSONObject("data/" + name + ".json");
    height = data.getInt("height");
    width  = data.getInt("width");
    JSONArray layers = data.getJSONArray("layers");
    JSONObject tmp;

    tmp = layers.getJSONObject(0);
    themap = tmp.getJSONArray("data").getIntArray();

    tmp = layers.getJSONObject(1);
    objects = tmp.getJSONArray("objects");

    tmp = data.getJSONObject("properties");
    energy = tmp.getInt("energy");
  }

  public int get(int x, int y) {
    return themap[(x+width*y)]-1;
  }
}
final int DIRUP    = 0;
final int DIRRIGHT = 1;
final int DIRDOWN  = 2;
final int DIRLEFT  = 3;

public int oposite_dir(int dir) {
  switch(dir){
  case DIRUP:
    return DIRDOWN;
  case DIRLEFT:
    return DIRRIGHT;
  case DIRDOWN:
    return DIRUP;
  case DIRRIGHT:
    return DIRLEFT;
  }
  exit();
  return 0;
}

class Trunk extends Things{
  Trunk (int x, int y, int dir, Things from){
    super(x,y);
    r = from.r;
    connected[dir] = true;
    next[dir] = from;
  }

  public Things move(int dir) {
    if(dir == DIRDOWN) {
      return super.move(dir);
    } else {
      return this;
    }
  }

  public void display() {
    super.display();            /* for selction */

    image(tiles[trunkTiles],xpos * SIZE, ypos * SIZE); /* a magic number ! */
  }

  public void debug(){
    print("x: ");
    print(xpos);
    print(" y: ");
    print(ypos);
    println("");
  }
}

class RootPart extends Things{
  RootPart (int x, int y, Root a){
    super(x,y);
    r = a;
  }

  RootPart (int x, int y, int dir, Things from){
    super(x,y);
    r = from.r;
    connected[dir] = true;
    next[dir] = from;
  }

  public void display() {
    int image = 0;

    image(tiles[easyDirtTiles],xpos * SIZE, ypos * SIZE);
    super.display_connected(true);
  }

  public void debug(){
    print("x: ");
    print(xpos);
    print(" y: ");
    print(ypos);
    println("");
  }
}

class Root {
  ArrayList<Things> parts = new ArrayList<Things>();

  Root (int x, int y) {
    parts.add(new RootPart(x,y,this));
  }

  public void display() {                 /* pensez \u00e0 la couleur */
    for (Things part : parts) {
      /* part.debug(); */
      part.display();
    }
  }

  public void add(Things part){
    parts.add(part);
  }

  public Things seed() {
    return parts.get(0);
  }
}
  public void settings() {  size(1324,700); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "growing" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
